#!/bin/bash
debug=yes_

function format () {

echo Formatting partition $1 with type $2

if test "$2" = "rfs"; then 
 echo y | fsdisk.sh reiser none none $1 &> /dev/null
elif test "$2" = "rfsnotail"; then
 echo y | fsdisk.sh reiser none -o\ notail $1 &> /dev/null
elif test "$2" = "xfs"; then
 echo y | fsdisk.sh xfs -f none $1 &> /dev/null
elif test "$2" = "jfs"; then
 echo y | fsdisk.sh jfs none none $1 &> /dev/null
elif test "$2" = "ext2"; then
 echo y | fsdisk.sh ext2 "-b 4096 -N 350000 -m 0" none $1 &> /dev/null
else
 echo unknown type $2
fi
}

function clsync() {
local dir=$1
if test -z "$dir"; then return; fi
local str=`mount | grep $dir`
local dev=`echo $str | cut -f 1 -d\ `
local type=`echo $str | cut -f 5 -d\ `
local opt=""

if test -n "`echo $str | grep notail`" ; then
 opt="-o notail"
fi

umount $dev
sleep 2
echo mounting $dev $dir -t $type $opt
mount $dev $dir -t $type $opt
}

function getseed() {
#local a
#local b
#let a=`date "+%M"`;
#let b=`date "+%S"`;
#echo $(($a * $b))
#echo `date "+%s"`
echo $RANDOM
}

function run () {
if test "$debug" = "yes"; then 
 echo $fdesc
 return 
fi

local wpart=1
local wdir=/mnt/scsi$wpart
local cpart=2
local cdir=/mnt/scsi$cpart
local workdir=`pwd`

local tmpdir=/tmp/results-root/agetest/`date "+%s"`-$fdesc
mkdir -p $tmpdir

local i
local run
local sfile
local wsfile
local agefile
local oldagefile
local seed

if test -z "$loopstr"; 	then loopstr="rfs rfsnotail ext2"; fi
if test -z "$formatstr";then formatstr="yes"; fi
if test -z "$copystr"; 	then copystr="yes"; fi

if test -z "$maxrun"; 	then maxrun="10"; fi
if test -z "$gaugeu"; 	then gaugeu="65"; fi
if test -z "$ageu"; 	then ageu="60:80"; fi
if test -z "$pparam"; 	then pparam="1000:200000"; fi
if test -z "$cparam"; 	then cparam="1:1"; fi

for i in $loopstr; do

if test "$formatstr" = "yes"; then
 format $wpart $i
fi
if test "$copystr" = "yes"; then
 format $cpart $i
fi
 sleep 3

 if test -n "$preallocstr"; then
  /root/bin/preallocate -d $wdir $preallocstr
 fi
  
 run=0
 while [ $run -lt $maxrun ]; do

  agefile=$tmpdir/agefile-$i-run$run
  sfile=$tmpdir/$fdesc-$i-run$run
  seed=`getseed`
  echo working on $sfile
#gauge
  if test "$run" = "0"; then
   /root/bin/agesystem3 -m 1 -c $cparam -d $wdir -u 0:$gaugeu -l 6:$lparam:$mparam -s $agefile -y $seed -p $pparam -z $gparam -t > $sfile.settings
   time /root/bin/agesystem3 -m 1 -c $cparam -d $wdir -u 0:$gaugeu -l 6:$lparam:$mparam -s $agefile -y $seed -p $pparam -z $gparam > $sfile
  else
#age
   /root/bin/agesystem3 -m 2 -c $cparam -d $wdir -u $ageu -l 6:$lparam:$mparam -r $oldagefile -s $agefile -y $seed -p $pparam -z $aparam -t > $sfile.settings
   time /root/bin/agesystem3 -m 2 -c $cparam -d $wdir -u $ageu -l 6:$lparam:$mparam -r $oldagefile -s $agefile -y $seed -p $pparam -z $aparam > $sfile
  fi
  echo ------------
  echo
  oldagefile=$agefile

  clsync $wdir

if test "$copystr" = "yes"; then
#cp
  format $cpart $i
  clsync $cdir

  wsfile=$tmpdir/$fdesc-$i-copy-run$run
  cp $sfile $wsfile
  echo working on $wsfile
  cd $wdir
  time cp -R . $cdir
  echo ------------
  echo
  cd $workdir

  clsync $wdir
  clsync $cdir
fi

#fibmap
  sfile=$tmpdir/$fdesc-$i-run$run-fibmap
  echo working on $sfile
  time /root/bin/fibmap $wdir > $sfile
  echo ------------
  echo

  clsync $wdir

if test "$copystr" = "yes"; then
  clsync $cdir
#cp
  wsfile=$tmpdir/$fdesc-$i-copy-run$run-fibmap
  echo working on $wsfile
  time /root/bin/fibmap $cdir > $wsfile
  echo ------------
  echo

  clsync $wdir
  clsync $cdir
fi

#read
  sfile=$tmpdir/$fdesc-$i-run$run-readtest
  echo working on $sfile
  time /root/bin/readtest -l $((1 * $gaugeu * 10000)) -d $wdir -y $seed -p $pparam -z $rparam . > $sfile
  echo ------------
  echo

  clsync $wdir

if test "$copystr" = "yes"; then
  clsync $cdir

#cp
  wsfile=$tmpdir/$fdesc-$i-copy-run$run-readtest
  echo working on $wsfile
  time /root/bin/readtest -l $((1 * $gaugeu * 10000)) -d $cdir -y $seed -p $pparam -z $rparam . > $wsfile
  echo ------------
  echo

  clsync $wdir
  clsync $cdir
fi
  run=$(($run + 1)) 
 done
done

sleep 3
}

RANDOM=`date "+%s"`
sleep 5


#--------------------------------------------------------
#	done
#--------------------------------------------------------

loopstr="rfs ext2 rfsnotail"
#loopstr="ext2"
#preallocstr="-c 1:1 -n $n"
preallocstr=""

fdesc=age-1GB-1x1-smem-248ac1
maxrun=25
gaugeu=65
ageu=65:85
lparam=2048:65536:524288
mparam=65536:524288:4194304
pparam="100:250000"
cparam="1:1"
gparam=""
aparam="-n 10000"
rparam=""
#run ; 

